bool showUI = true;
bool ChatPermission = false;
bool deleteChat = true;
int ChatSpam;
string Chat = "";
string pluginName = "\\$FCD" + Icons::KeyboardO + "\\$z Royal Chat Bug Bypass";

void Main()
{
	print("Plugin loaded!");
	if (Permissions::InGameChat())
	{
		ChatPermission = true;
	}
	else {
		error("Missing permission InGameChat");
	}
}

void RenderInterface()
{
	if (!showUI) return;
	if (!ChatPermission) return;
	CTrackMania@ app = cast<CTrackMania>(GetApp());
	CSmArenaClient@ playground = cast<CSmArenaClient>(cast<CTrackMania>(GetApp()).CurrentPlayground);
	auto serverInfo = cast<CGameCtnNetServerInfo>(cast<CTrackManiaNetwork>(GetApp().Network).ServerInfo);
	if (app.RootMap !is null && playground !is null && serverInfo.ModeName == "TM_Royal_Online")
	{
		CGamePlaygroundInterface@ playgroundInterface = cast<CGamePlaygroundInterface>(playground.Interface);
		UI::Begin(pluginName, showUI, UI::WindowFlags::NoCollapse | UI::WindowFlags::AlwaysAutoResize);
		UI::Text("Chat");
		Chat = UI::InputText("##RoyalChat", Chat);
		bool ChatSend = false;
		if (ChatSpam > 0)
		{
			UI::BeginDisabled();
		}
		UI::SameLine();
		if (UI::Button("Send"))
		{
			playgroundInterface.ChatEntry = Chat;
			if (deleteChat)
			{
				Chat = "";
			}
			ChatSend = true;
		}
		UI::SameLine();
		if (UI::Button("Send to Team"))
		{
			playgroundInterface.ChatEntry = "/t " + Chat;
			if (deleteChat)
			{
				Chat = "";
			}
			ChatSend = true;
		}
		if (ChatSpam > 0)
		{
			UI::EndDisabled();
			ChatSpam--;
		}
		deleteChat = UI::Checkbox("Delete last Message after sending?", deleteChat);
		UI::Separator();
		UI::Markdown(Icons::DiscordAlt + " [Join the Royal Family Discord!](https://dsc.gg/royal-family) ");
		UI::Markdown(Icons::Trophy + " [Royal World Records Leaderboard](https://www.royalfamilytm.com/records)");
		UI::Markdown(Icons::YoutubePlay + " [Royal Records on YouTube](https://www.youtube.com/@Royal_Records)");
		UI::Markdown(Icons::Map + " [List of current and old maps](https://royalgraveyard.jeffs.rocks/pool/)");
		UI::Markdown(Icons::ListOl + " [Royal Toplist](https://trackmania.io/#/top/royal)");
		UI::Text("\n\\$777v" + Meta::ExecutingPlugin().Version);
		UI::End();
		if (ChatSend)
		{
			ChatSpam = 500;
		}
	}
}

void RenderMenu() {
	if (!ChatPermission) return;
	if (UI::MenuItem(pluginName, "", showUI))
	{
		showUI = !showUI;
	}
}